<!DOCTYPE html>
<!--
 *  Copyright (c) 2015 The WebRTC project authors. All Rights Reserved.
 *
 *  Use of this source code is governed by a BSD-style license
 *  that can be found in the LICENSE file in the root of the source
 *  tree.
-->
<html>
<head>

  <meta charset="utf-8">
  <meta name="description" content="WebRTC code samples">
  <meta name="viewport" content="width=device-width, user-scalable=yes, initial-scale=1, maximum-scale=1">
  <meta itemprop="description" content="Client-side WebRTC code samples">
  <meta itemprop="image" content="../../../images/webrtc-icon-192x192.png">
  <meta itemprop="name" content="WebRTC code samples">
  <meta name="mobile-web-app-capable" content="yes">
  <meta id="theme-color" name="theme-color" content="#ffffff">

  <base target="_blank">

  <title>Transmit text</title>


</head>

<body>

  <div id="container">

    <h1><a href="//webrtc.github.io/samples/" title="WebRTC samples homepage">WebRTC samples</a> <span>Transmit text</span></h1>

    <div id="buttons">
      <button id="startButton">Start</button>
      <button id="sendButton" disabled>Send</button>
      <button id="closeButton" disabled>Stop</button>
    </div>

    <div id="sendReceive">
      <div id="send">
        <h2>Send</h2>
        <textarea id="dataChannelSend" disabled placeholder="Press Start, enter some text, then press Send."></textarea>
      </div>
      <div id="receive">
        <h2>Receive</h2>
        <textarea id="dataChannelReceive" disabled></textarea>
      </div>
    </div>

    <p>View the console to see logging.</p>

    <p>The <code>RTCPeerConnection</code> objects <code>localConnection</code> and <code>remoteConnection</code> are in global scope, so you can inspect them in the console as well.</p>

    <p>For more information about RTCDataChannel, see <a href="http://www.html5rocks.com/en/tutorials/webrtc/basics/#toc-rtcdatachannel" title="RTCDataChannel section of HTML5 Rocks article about WebRTC">Getting Started With WebRTC</a>.</p>

    <a href="https://github.com/webrtc/samples/tree/gh-pages/src/content/datachannel/basic" title="View source for this page on GitHub" id="viewSource">View source on GitHub</a>
  </div>

  <script src="https://webrtc.github.io/adapter/adapter-latest.js"></script>
  <script src="../../../js/common.js"></script>
  <script>
  
	  /*
	   *  Copyright (c) 2015 The WebRTC project authors. All Rights Reserved.
	   *
	   *  Use of this source code is governed by a BSD-style license
	   *  that can be found in the LICENSE file in the root of the source
	   *  tree.
	   */
	
	  'use strict';
	
	  var localConnection;
	  var remoteConnection;
	  var sendChannel;
	  var receiveChannel;
	  var pcConstraint;
	  var dataConstraint;
	  var dataChannelSend = document.querySelector('textarea#dataChannelSend');
	  var dataChannelReceive = document.querySelector('textarea#dataChannelReceive');
	  var startButton = document.querySelector('button#startButton');
	  var sendButton = document.querySelector('button#sendButton');
	  var closeButton = document.querySelector('button#closeButton');
	
	  startButton.onclick = createConnection;
	  sendButton.onclick = sendData;
	  closeButton.onclick = closeDataChannels;
	
	  function enableStartButton() {
	    startButton.disabled = false;
	  }
	
	  function disableSendButton() {
	    sendButton.disabled = true;
	  }
	
	  function createConnection() {
	    dataChannelSend.placeholder = '';
	    var servers = null;
	    pcConstraint = null;
	    dataConstraint = null;
	    
	    console.log('Using SCTP based data channels');
	    // SCTP is supported from Chrome 31 and is supported in FF.
	    // No need to pass DTLS constraint as it is on by default in Chrome 31.
	    // For SCTP, reliable and ordered is true by default.
	    // Add localConnection to global scope to make it visible
	    // from the browser console.
	    window.localConnection = new RTCPeerConnection(servers, pcConstraint);
	    console.log('Created local peer connection object localConnection');
	
	    sendChannel = localConnection.createDataChannel('sendDataChannel', dataConstraint);
	    console.log('Created send data channel');
	
	    localConnection.onicecandidate = function(e) {
	      onIceCandidate(localConnection, e);
	    };
	    sendChannel.onopen = onSendChannelStateChange;
	    sendChannel.onclose = onSendChannelStateChange;
	
	    // Add remoteConnection to global scope to make it visible
	    // from the browser console.
	    window.remoteConnection = remoteConnection = new RTCPeerConnection(servers, pcConstraint);
	    console.log('Created remote peer connection object remoteConnection');
	
	    remoteConnection.onicecandidate = function(e) {
	      onIceCandidate(remoteConnection, e);
	    };
	    remoteConnection.ondatachannel = receiveChannelCallback;
	
	    localConnection.createOffer().then(
	      gotDescription1,
	      onCreateSessionDescriptionError
	    );
	    startButton.disabled = true;
	    closeButton.disabled = false;
	  }
	
	  function onCreateSessionDescriptionError(error) {
	    console.log('Failed to create session description: ' + error.toString());
	  }
	
	  function sendData() {
	    var data = dataChannelSend.value;
	    sendChannel.send(data);
	    console.log('Sent Data: ' + data);
	  }
	
	  function closeDataChannels() {
	    console.log('Closing data channels');
	    sendChannel.close();
	    console.log('Closed data channel with label: ' + sendChannel.label);
	    receiveChannel.close();
	    console.log('Closed data channel with label: ' + receiveChannel.label);
	    localConnection.close();
	    remoteConnection.close();
	    localConnection = null;
	    remoteConnection = null;
	    console.log('Closed peer connections');
	    startButton.disabled = false;
	    sendButton.disabled = true;
	    closeButton.disabled = true;
	    dataChannelSend.value = '';
	    dataChannelReceive.value = '';
	    dataChannelSend.disabled = true;
	    disableSendButton();
	    enableStartButton();
	  }
	
	  function gotDescription1(desc) {
	    localConnection.setLocalDescription(desc);
	    console.log('Offer from localConnection \n' + desc.sdp);
	    remoteConnection.setRemoteDescription(desc);
	    remoteConnection.createAnswer().then(
	      gotDescription2,
	      onCreateSessionDescriptionError
	    );
	  }
	
	  function gotDescription2(desc) {
	    remoteConnection.setLocalDescription(desc);
	    console.log('Answer from remoteConnection \n' + desc.sdp);
	    localConnection.setRemoteDescription(desc);
	  }
	
	  function getOtherPc(pc) {
	    return (pc === localConnection) ? remoteConnection : localConnection;
	  }
	
	  function getName(pc) {
	    return (pc === localConnection) ? 'localPeerConnection' : 'remotePeerConnection';
	  }
	
	  function onIceCandidate(pc, event) {
	    getOtherPc(pc).addIceCandidate(event.candidate)
	    .then(
	      function() {
	        onAddIceCandidateSuccess(pc);
	      },
	      function(err) {
	        onAddIceCandidateError(pc, err);
	      }
	    );
	    console.log(getName(pc) + ' ICE candidate: \n' + (event.candidate ? event.candidate.candidate : '(null)'));
	  }
	
	  function onAddIceCandidateSuccess() {
	    console.log('AddIceCandidate success.');
	  }
	
	  function onAddIceCandidateError(error) {
	    console.log('Failed to add Ice Candidate: ' + error.toString());
	  }
	
	  function receiveChannelCallback(event) {
	    console.log('Receive Channel Callback');
	    receiveChannel = event.channel;
	    receiveChannel.onmessage = onReceiveMessageCallback;
	    receiveChannel.onopen = onReceiveChannelStateChange;
	    receiveChannel.onclose = onReceiveChannelStateChange;
	  }
	
	  function onReceiveMessageCallback(event) {
	    console.log('Received Message');
	    dataChannelReceive.value = event.data;
	  }
	
	  function onSendChannelStateChange() {
	    var readyState = sendChannel.readyState;
	    console.log('Send channel state is: ' + readyState);
	    if (readyState === 'open') {
	      dataChannelSend.disabled = false;
	      dataChannelSend.focus();
	      sendButton.disabled = false;
	      closeButton.disabled = false;
	    } else {
	      dataChannelSend.disabled = true;
	      sendButton.disabled = true;
	      closeButton.disabled = true;
	    }
	  }
	
	  function onReceiveChannelStateChange() {
	    var readyState = receiveChannel.readyState;
	    console.log('Receive channel state is: ' + readyState);
	  }
	

  
  </script>

  <script src="../../../js/lib/ga.js"></script>

</body>
</html>

